=begin
#WeFitter API

#This is the WeFitter API

OpenAPI spec version: v1.3
Contact: hello@wefitter.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.38
=end

require 'uri'

module WeFitter
  class ConnectionApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Connect wearable
    # Get OAuth URL for this connection.
    # @param connection_slug 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AppConnectionUrl]
    def connection_connect_create(connection_slug, data, opts = {})
      data, _status_code, _headers = connection_connect_create_with_http_info(connection_slug, data, opts)
      data
    end

    # Connect wearable
    # Get OAuth URL for this connection.
    # @param connection_slug 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppConnectionUrl, Fixnum, Hash)>] AppConnectionUrl data, response status code and response headers
    def connection_connect_create_with_http_info(connection_slug, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConnectionApi.connection_connect_create ...'
      end
      # verify the required parameter 'connection_slug' is set
      if @api_client.config.client_side_validation && connection_slug.nil?
        fail ArgumentError, "Missing the required parameter 'connection_slug' when calling ConnectionApi.connection_connect_create"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ConnectionApi.connection_connect_create"
      end
      # resource path
      local_var_path = '/connection/{connection_slug}/connect/'.sub('{' + 'connection_slug' + '}', connection_slug.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerProfile']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppConnectionUrl')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConnectionApi#connection_connect_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Disconnect Wearable
    # Disconnect a wearables connection
    # @param connection_slug 
    # @param profile A profile public_id is expected
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def connection_connect_delete(connection_slug, profile, opts = {})
      connection_connect_delete_with_http_info(connection_slug, profile, opts)
      nil
    end

    # Disconnect Wearable
    # Disconnect a wearables connection
    # @param connection_slug 
    # @param profile A profile public_id is expected
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def connection_connect_delete_with_http_info(connection_slug, profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConnectionApi.connection_connect_delete ...'
      end
      # verify the required parameter 'connection_slug' is set
      if @api_client.config.client_side_validation && connection_slug.nil?
        fail ArgumentError, "Missing the required parameter 'connection_slug' when calling ConnectionApi.connection_connect_delete"
      end
      # verify the required parameter 'profile' is set
      if @api_client.config.client_side_validation && profile.nil?
        fail ArgumentError, "Missing the required parameter 'profile' when calling ConnectionApi.connection_connect_delete"
      end
      # resource path
      local_var_path = '/connection/{connection_slug}/connect/'.sub('{' + 'connection_slug' + '}', connection_slug.to_s)

      # query parameters
      query_params = {}
      query_params[:'profile'] = profile

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerProfile']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConnectionApi#connection_connect_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
